/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author samu
 */

import java.net.*;
import java.io.*;
public class serverTCP {
    private final morseUI gui;
    private BufferedReader s_in;
    private DataOutputStream s_out;
    private ServerSocket socket;
    private Socket socket_cli;
    public boolean tcpConnected = false;
    public boolean appIsClosing = false;
    
    /* Constructor */
    public serverTCP(morseUI gui) {
        
        this.gui = gui;
    }
    
    
    /* Start TCP Server */
    public void startTCP() {
        
        boolean fin = false;
        String message;
        
        try {
            socket = new ServerSocket(6001);
            socket_cli = new Socket();
            gui.setCommLed(0);

            socket_cli = socket.accept();


            gui.setCommLed(1);
            gui.setLPCLed(1);

            s_in = new BufferedReader(new InputStreamReader(socket_cli.getInputStream()));
            s_out = new DataOutputStream(socket_cli.getOutputStream());

            do {
                tcpConnected = socket_cli.isConnected();
                message = s_in.readLine();
                if (message.startsWith("FIN"))
                    fin = true;
                else {
                    if (message.contains("!#"))
                        setLPCOptions(message);
                    else {
                        if (message.contains("¡#")) {
                            if (message.contains("¡#OK"))
                                gui.enableControls();
                            else
                                gui.disableControls();
                        }
                        else
                            gui.updateReceivedTextUI(message, false);
                    }
                }

            } while (!fin && tcpConnected);
            closeConnection();
            gui.setCommLed(0);
        } catch (IOException e) {
            System.err.println(e.getMessage());
        }
    }
    
    private void setLPCOptions(String options) {
        String lpcOptions[];
        int freq = 0;
        int wpm = 0;
        int vol = 0;
        
        lpcOptions = options.split("#");
        for(int i =1; i < lpcOptions.length ; i++) {
            switch(i){
                case 1:
                    freq = Integer.parseInt(lpcOptions[i]);
                    break;
                case 2:
                    wpm = Integer.parseInt(lpcOptions[i]);
                    break;
                case 3:
                    vol = Integer.parseInt(lpcOptions[i]);
                    break;
            }
        }
        gui.setControlValues(freq, wpm, vol);
    }
    
    /* Send text to Wifly */
    public void sendToWifly(String str) {
        try {
            s_out.writeBytes(str);
        } catch (IOException e) {
            gui.setCommLed(0);
            System.err.println(e.getMessage());
        }
    }
    
    /* Check if Wifly is online */
    public boolean isWiflyOnline() {
        
        return tcpConnected;
    }
    
        /* Terminate TCP connection with Wifly */
    public void closeConnection() {
        
        try {
            s_in.close();
            s_out.close();
            socket_cli.close();
            socket.close();
            tcpConnected = false;
        }
        catch (IOException e) {
            System.err.println(e.getMessage());
        }
    }
    
    /* Close connection and exit from server */
    public void terminateToCloseApp() {
        
        appIsClosing = true;
        if (tcpConnected)
            tcpConnected = false;
        if (!socket.isClosed())
            closeConnection(); 
    }
    
    public static void main(String args[]) {
        /* Main method class, void */
    }
    
}
