/*
 * delay.h
 *
 *  Library created to provide active and passive delays.
 *
 *  Created on: 24/10/2013
 *  Author:  Samuel Melero Cuesta
 *  Version: 2.0
 *
 */

#ifndef DELAY_H_
#define DELAY_H_

/*****************************************************************************
** Function name:		activeDelay
**
** Descriptions:		Performs active wait
**
** parameters:			milliseconds to wait
** Returned value:		None
**
*****************************************************************************/
void activeDelay(uint32_t msecs);

/*****************************************************************************
** Function name:		passiveDelay
**
** Descriptions:		Performs passive wait. No processing power is wasted.
**
** parameters:			milliseconds to wait
** Returned value:		None
**
*****************************************************************************/
void passiveDelay(uint32_t msecs);

#endif /* DELAY_H_ */
