/*
 * led.h
 *
 *  Created: 26/09/2013
 *  Author:  Samuel Melero Cuesta
 *  Version: 1.0
 *
 */


#ifndef LED_H_
#define LED_H_

/* The bit of port 0 that the LPCXpresso LPC13xx LED is connected. */
#define mainLED_BIT 						( 22 )

/* Function name: 	led_init
 *
 * Description: 	Initializes led function.
 *
 *
 * Parameters: 		None.
 * Return:			None.
 */
void led_init();

/* Function name: 	led_on
 *
 * Description: 	Performs led on.
 *
 *
 * Parameters: 		None.
 * Return:			None.
 */
void led_on();

/* Function name: 	led_off
 *
 * Description: 	Performs led off.
 *
 *
 * Parameters: 		None.
 * Return:			None.
 */
void led_off();

/* Function name: 	led_toggle
 *
 * Description: 	Performs led off from on state and led on from off state.
 *
 *
 * Parameters: 		None.
 * Return:			None.
 */
void led_toggle();

#endif /* LED_H_ */
