/*
 * delay.c
 *
 *  Library created to provide active and passive delays.
 *
 *  Created on: 24/10/2013
 *  Author:  Samuel Melero Cuesta
 *  Version: 2.0
 *
 */
#include "FreeRTOS.h"
#include "task.h"
#include "type.h"
#include "delay.h"

void activeDelay(uint32_t msecs) {
	uint32_t i;

	// 7140 iterations are 1msec
	for (i=0; i<( ((uint32_t)7140) * msecs) ; i++);
}

void passiveDelay(uint32_t msecs) {

	/* Check if there are any task to suspend */
	/* WARNING: Call to vTaskDelay without tasks running causes HardFault */
	if (uxTaskGetNumberOfTasks() == 0U)
		activeDelay(msecs);
	else
		vTaskDelay(msecs / portTICK_RATE_MS);
}
