/*
 * led.c
 *
 *  Created: 26/09/2013
 *  Author:  Samuel Melero Cuesta
 *  Version: 1.0
 *
 */

#include "led.h"
#include "LPC17xx.h"

#define h_value 	( 1 << mainLED_BIT )
#define l_value		( 0x00 )


void led_init() {
	/* Initialize P0_22 for the LED */
	LPC_PINCON->PINSEL1	&= ( ~( 3 << 12 ) );
	LPC_GPIO0->FIODIR |= h_value;

	/* Initialize LED to OFF */
	led_off();
}

void led_on() {
	/* Set the LED to ON state */
	LPC_GPIO0->FIOCLR = l_value;
	LPC_GPIO0->FIOSET = h_value;
}

void led_off() {
	/* Set the LED to OFF state */
	LPC_GPIO0->FIOCLR = h_value;
	LPC_GPIO0->FIOSET = l_value;
}

void led_toggle() {
	/* local variables */
	unsigned long ulLEDState;

	/* Obtain the current P0 state. */
	ulLEDState = LPC_GPIO0->FIOPIN;

	/* Set the LED to the opposite state */
	if ( !( ulLEDState & h_value ) )
		led_on();
	else
		led_off();
}
