/*
 * tools.c
 *  Useful functions
 *
 *  Created on: 30/10/2013
 *  Author:  Samuel Melero Cuesta
 *  Version: 2.0
 *
 */

#include "type.h"
#include "tools.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



void vDelimChars(char* cStrIn, char* cStrOut, char* cDelimIni, char* cDelimEnd, uint32_t ulOffset) {

	strcpy(cStrOut, strtok(strstr(cStrIn, cDelimIni)+ulOffset, cDelimEnd));
}


void cpChangeBlanks(char* pcText) {
	char* ct = NULL;

	while ((ct = strchr(pcText, ' ')) != NULL) {
		*ct++ = WF_BLANK_CHAR;
	}
}

void parseOptionData(char* string, uint32_t* freq, uint32_t* speed, float* volume)
{
	uint32_t i = 0;
	char* pch;

	pch = strtok(string, "!*#");
	while (pch != NULL) {
		switch (i) {
		case 0:
			*freq = atoi(pch);
			break;
		case 1:
			*speed = atoi(pch);
			break;
		default:
			*volume = (float)atoi(pch);
		}
		pch = strtok(NULL, "!*#");
		i++;
	}
}

void strCopy(const char* source, char* dest)
{
	strcpy(dest, source);
}

uint32_t strContains(const char* string, const char* subString)
{
	if (strstr(string, subString) != NULL)
		return TRUE;
	else
		return FALSE;
}

uint32_t strContainsCRLF(char* string)
{
	if (string[strlen(string)-1] != '\n')
		return FALSE;
	else
		return TRUE;
}

void strRemoveCRLF(char* string)
{
	string[strlen(string)-2] = '\0';
}
